/*@Override */
function DisableParentPageScroll(){

	var lastY = 0;
	document.ontouchstart = function(e) {
		var currentY = e.targetTouches[0].pageY;
		lastY = currentY;	
		console.log('lastY'+lastY)
	}
	document.ontouchmove = function(e) {
		var $target = $(e.target);
		var st = $('#bibMulti2').scrollTop();
		var currentY = e.targetTouches[0].pageY;
		var scrollerEndPoint = $("#bibMulti2")[0].scrollHeight - $("#bibMulti2").height();
		if (currentY > lastY && st == 0 ){
			console.log('down scroll');
			return false;
		} else if (currentY < lastY && (scrollerEndPoint<(st+40) )){
			console.log('up scroll');
			return false;
		} else if($target.is('.bibMultiContainer')) {
			return false;
		} else {
			return true;
		}

		lastY = currentY;
	}
}

/*@Override */
function EnableParentPageScroll(){
	window.MyJavaScriptInterface.onRefPopupClose();
	document.ontouchmove = function(e){ return true; }
	var lstmulti = $('#bibMulti2');
	$(lstmulti).parent().hide();
	$(lstmulti).hide();
}

function isPopupVisible() {
	return $('#bibMulti2').is(':visible');
}

$(function() {
	$('.bibMultiContainer').css('display', 'none');
	$('#bibMulti2').css('display', 'none');

	$('body').css('overflowY', 'hidden');
});

window.addEventListener("orientationchange", function() {
	setTimeout(function() {
		$('.bibMultiContainer').css({
			"width": window.innerWidth,
			"height": window.innerHeight,
			"position": "fixed",
			"top": "0",
			"left": "0",
		});
	}, 400);

	setTimeout(function() {
		$('.bibMultiContainer').css({
			"width": window.innerWidth,
			"height": window.innerHeight,
			"position": "fixed",
			"top": "0",
			"left": "0",
		});
	}, 1500);


	$('#bibMulti2').css({
		"position": "relative",
		"top": "50%",
		"left": "50%",
		"margin": "0"
	});

	if(window.innerHeight > 480){
		$('#bibMulti2').css({"max-height":"600px", "width":"60%", "padding": "19px"});
	} else{
		$('#bibMulti2').css({"max-height":"360px", "width":"85%", "padding": "13px"});
	}
}, false);

window.addEventListener("resize", function() {
	if(isPopupVisible()) {
		resetPopup();
	}
}, false);

function resetPopup() {
	setTimeout(function() {
		onSetTimeout();
	}, 500);

	setTimeout(function() {
		onSetTimeout();
	}, 1500);

	$('#bibMulti2').css({
		"position": "relative",
		"top": "50%",
		"left": "50%",
		"margin": "0"
	});

	if(window.innerHeight > 480){
		$('#bibMulti2').css({"max-height":"600px", "width":"60%", "padding": "19px"});
	} else{
		$('#bibMulti2').css({"max-height":"360px", "width":"85%", "padding": "13px"});
	}
}

function onSetTimeout() {
	$('.bibMultiContainer').css({
		"width": window.innerWidth,
		"height": window.innerHeight,
		"position": "fixed",
		"top": "0",
		"left": "0",
	});
}

function attachTableEvents() {

	$(document).on('touchstart', 'table', function(e){
		window.MyJavaScriptInterface.onTableClickedDown();
		console.log('clicked Down on table')
		// e.preventDefault();

	});

	$(document).on('touchend mouseover touchcancel', 'table', function(e){
		window.MyJavaScriptInterface.onTableClickedUp();
		console.log('clicked UP on table ')
		//e.preventDefault();  
	});
}

function addAbstractFooterLayout(str) {
	var $abstractFooterLayout = $('#abstract_footer_layout');
	if($abstractFooterLayout.length){
		$abstractFooterLayout.remove();
	}
	if(str) {
		var str = str.toUpperCase();			
		var footerLayoutHtml = null;
		if(str == 'DOWNLOAD_BUTTON_ARTICLE'){
			footerLayoutHtml = '<div class="font_style" id="abstract_footer_layout"><p>To read the full text article,</p><a href="startdownloading" class="download_button_link"><label class="download_button">Download Article</label></a></div>';
		} else if(str == 'DOWNLOADING_SPINNER_ARTICLE'){
			footerLayoutHtml = '<div id="abstract_footer_layout"><div id="downloading_layout" class="font_style"><table><tr><td><div class="loading"><div class="outer"></div><div class="inner"></div></div></td><td id="text">Downloading Article</td></tr></table></div><div>';
		} else if (str == 'GO_TO_FULL_TOC') {
		    footerLayoutHtml = '<div class="font_style" id="abstract_footer_layout"><p>To read the full text article,</p><a href="fulltoc" class="download_button_link"><label class="download_button">Go to Full TOC</label></a></div>';
		}
		
		if(footerLayoutHtml) {
			var linkTag = '<link rel="stylesheet" href="file:///android_asset/loader.css" type="text/css">';			
			if (!$("link[href='file:///android_asset/loader.css']").length) {
				$(linkTag).appendTo("head");
			}
			$('body').append(footerLayoutHtml);		
		}
	}
}